/*
   All emon_widgets code is released under the GNU General Public License v3.
   See COPYRIGHT.txt and LICENSE.txt.

    ---------------------------------------------------------------------
    Part of the OpenEnergyMonitor project:
    http://openenergymonitor.org

    Author: Trystan Lea: trystan.lea@googlemail.com
    If you have any questions please get in touch, try the forums here:
    http://openenergymonitor.org/emon/forum
 */

function feedtext_widgetlist()
{
  var widgets = {
    "feedtext": 
    {
      "offsetx":-40,"offsety":-30,"width":80,"height":120,
      "menu":"Widgets",
      "options":["feedname1","text10","text11","polje_blink","polje_shadow","fsize","ploca1"],
      "optionstype":["feed","value","value","value","value","value","value"],
      "optionsname":[_Tr("Feed1"),_Tr("Text1 0"),_Tr("Text1 1"),_Tr("Text 1 blink"),_Tr("Shadow color"),_Tr("Font size"),_Tr("Dashboard")],
      "optionshint":[_Tr("Feed1 value"),_Tr("Text1 for 0 state"),_Tr("Text1 for 1 state"),_Tr("0 / 1"),_Tr(" hex"),_Tr(" px"),_Tr("call Dashboard")] 
    }
  };
  return widgets;
}

function feedtext_init()
{
  feedtext_draw();
}

function feedtext_draw()
{
  $('.feedtext').each(function(index)
  {
    var feed1 = $(this).attr("feedname1");
    if (feed1===undefined) feed1 = $(this).attr("feed");

    var text10 = $(this).attr("text10");
    var text11 = $(this).attr("text11");
    var val1 = assoc[feed1];

    var dimx = $(this).width();
    var dimy = $(this).height()/2;
    
    var polje_blink = $(this).attr("polje_blink");
    if (polje_blink===undefined) polje_blink = 0;
    
    var polje_shadow = $(this).attr("polje_shadow");
    if (polje_shadow===0)
    {
     polje_shadow = "";
    } else {
     polje_shadow = "; box-shadow: 5px 5px 2px "+$(this).attr("polje_shadow");
    }
    
    var fsize = $(this).attr("fsize");
    if (fsize===undefined) fsize = '15';

    if (text10===undefined) text10 = '';
    if (text11===undefined) text11 = '';
    if (val1===undefined) val1 = 0;
    
    var textout1= "";
   
    //var snd = new Audio("/obv/Modules/dashboard/Views/js/sound/beep-08b.mp3");  

    var ploca1 = $(this).attr("ploca1");
    if (ploca1===undefined) ploca1 = 0;

    var kursor = "";
    var color1 = "";
    var colorg = "rgb(50,200,50)";  //zelena
    var colorr = "red";  // crvena
    var colorw = "rgb(255, 255, 255)";  // bjela
    var coloro = "orange"; // 
    
    var HOMEfeed = feed1.search("HOME");
    
    if (HOMEfeed >-1) {
       color1 = coloro;
    } else {
    
       color1 = colorr;
    }
       
    if (ploca1 > 0) {   
      kursor = "; cursor:pointer";
    } else { 
      kursor = "";
    }
    var interval_feedtext ;
    clearInterval(interval_feedtext) ;
    var interval_beep ;
    clearInterval(interval_beep) ;

    if (val1 === 0) {
      textout1 = "<div class ='green_noblink' style=' width:"+dimx+"px; height:"+dimy+"px; margin:auto; text-align:center; border:1px solid grey; font-family:verdana; font-size:"+fsize+"px; color:white; background-color:green"+polje_shadow+"; border-radius: 5px" +kursor+" '> "+text10+" </div> ";
      //var snd= '';
      //alarm_stop(snd);
      
   
    } else {

       if (polje_blink==1) {
         
         interval_feedtext = setInterval(blinkerred, 1000); //Runs every second
         interval_beep = setInterval(alarm_beep(), 5000); //Runs every 5 seconds
         textout1 = "<div class ='blink_red' style=' width:"+dimx+"px; height:"+dimy+"px; margin:auto; text-align:center; border:1px solid grey; font-family:verdana; font-size:"+fsize+"px; color:white; background-color:"+color1+" "+polje_shadow+"; border-radius: 5px" +kursor+" '> "+text11+" </div> ";
       } else {
         textout1 = "<div class ='noblink_red' style=' width:"+dimx+"px; height:"+dimy+"px; margin:auto; text-align:center; border:1px solid grey; font-family:verdana; font-size:"+fsize+"px; color:white; background-color:"+color1+" "+polje_shadow+"; border-radius: 5px" +kursor+" '> "+text11+" </div> ";
       }
       
       

    }
              
     
      
    $(this).click(function() {
       
       if (ploca1 > 0) {
         snd = '';  
         window.location.href = 'http://emon-bns.com/obz/dashboard/view?id='+$(this).attr("ploca1");
       }
       
     });


     $(this).html(textout1); 

      
  

    
  });
}

function playSound(url) {
  var ourAudio = document.createElement('audio'); // Create a audio element using the DOM
  ourAudio.style.display = "none"; // Hide the audio element
  ourAudio.src = url; // Set resource to our URL
  ourAudio.autoplay = true; // Automatically play sound
  ourAudio.onended = function() {
    this.remove(); // Remove when played.
  };
  document.body.appendChild(ourAudio);
}

function feedtext_slowupdate()
{
  feedtext_draw();
}

function feedtext_fastupdate()
{
}

function blinkergreen()
{

$('.blink_green').fadeOut(500);
$('.blink_green').fadeIn(500);

}

function alarm_beep()
{
   
   //snd.play() ;
   playSound("/obz/Modules/dashboard/Views/js/sound/beep-08b.mp3");
}

function alarm_stop(snd)
{
   
   
   //snd.pause();

}

function blinkerred()
{
  
   $('.blink_red').fadeOut(500);
   $('.blink_red').fadeIn(500);
   
}