﻿<?php
  /*
   All Emoncms code is released under the GNU Affero General Public License.
   See COPYRIGHT.txt and LICENSE.txt.

    ---------------------------------------------------------------------
    Emoncms - open source energy visualisation
    Part of the OpenEnergyMonitor project:
    http://openenergymonitor.org

  */

  // no direct access
  defined('EMONCMS_EXEC') or die(_('Restricted access'));

  function vis_controller()
  {
    global $mysqli, $session, $route, $user, $timestore_adminkey;

    $result = false;
    $session['userid'] = 1;

    require "Modules/feed/feed_model.php";
    $feed = new Feed($mysqli,$timestore_adminkey);

    require "Modules/vis/multigraph_model.php";
    $multigraph = new Multigraph($mysqli);

    $visdir = "vis/visualisations/";
 
    /*
      1 - realtime
      2 - daily
      3 - histogram
      4 - boolean (not used uncomment line 122)
      5 - text
      6 - float value
      7 - int value
    */

    $visualisations = array(
      'realtime' => array('options'=>array(array('feedid',1))),
      'realtime24' => array('options'=>array(array('feedid',1),array('fill',7,0),array('units',5,'°C'))),
      'rawdata'=> array('options'=>array(array('feedid',1),array('fill',7,0),array('units',5,'°C'))),
      'rawmkt'=> array('options'=>array(array('feedid',1),array('fill',7,0),array('units',5,'°C'))),
      'bargraph'=> array('options'=>array(array('feedid',2),array('colour',5,'EDC240'))),
      'timestoredaily'=> array('options'=>array(array('feedid',1),array('units',5,'kWh'))),
      'smoothie'=> array('options'=>array(array('feedid',1),array('ufac',6))),
      'histgraph'=> array('options'=>array(array('feedid',3),array('barwidth',7,50),array('start',7,0),array('end',7,0))),
      //'dailyhistogram'=> array('options'=>array(array('feedid',3))),
      'zoom'=> array('options'=>array(array('power',1),array('kwhd',2),array('currency',5,'&pound;'),array('currency_after_val', 7, 0), array('pricekwh',6,0.14))),
      //'comparison'=> array('options'=>array(array('feedid',3))),
      'stacked'=> array('options'=>array(array('bottom',2),array('top',2))),
      'stackedsolar'=> array('options'=>array(array('solar',2),array('consumption',2))),
      'threshold'=> array('options'=>array(array('feedid',3),array('thresholdA',6,500),array('thresholdB',6,2500))),
      'simplezoom'=> array('options'=>array(array('power',1),array('kwhd',2))),
      'orderbars'=> array('options'=>array(array('feedid',2))),
      'orderthreshold'=> array('options'=>array(array('feedid',3),array('power',1),array('thresholdA',6,500),array('thresholdB',6,2500))),
      'editrealtime'=> array('options'=>array(array('feedid',1))),
      'editdaily'=> array('options'=>array(array('feedid',2))),
      'multigraph' => array ('action'=>'multigraph', 'options'=>array(array('mid',7)) ),
      'compare' => array ('action'=>'compare', 'options'=>array(array('powerx',1),array('powery',1))),
      'compare2017' => array ('action'=>'compare2017', 'options'=>array(array('feedA',1),array('feedB',1))),
      'compare2021' => array ('action'=>'compare2021', 'options'=>array(array('feedA',1),array('feedB',1))),
      'maping2021' => array ('action'=>'maping2021', 'options'=>array(array('feedA',1),array('feedB',1),array('feedC',1),array('feedD',1),array('feedE',1),array('feedF',1),array('feedG',1),array('feedH',1),array('feedI',1))),
      'graphtable' => array('options'=>array(array('feedid',2),array('units',5,'°C'))),
      'graphtable4h' => array('options'=>array(array('feedid',2),array('units',5,'°C'),array('datvr',5,'D')))

    );

    $write_apikey = ""; $read_apikey = "";
    if ($session['read']) $read_apikey = $user->get_apikey_read($session['userid']);
    if ($session['write']) $write_apikey = $user->get_apikey_write($session['userid']);
/*
                if (isset($_GET['start'])){
                  $_SESSION['dateod'] = strtotime($_GET["start"]) ;
                  //error_log("uzeo start iz vis\n", 3, "errori.log");
                  $session['dateod'] = $_SESSION['dateod']; 
                }
*/

    if ($route->format =='html')
    {
        if ($route->action == 'list' && $session['write'])
        {
            $multigraphs = $multigraph->getlist($session['userid']);
            $feedlist = $feed->get_user_feed_bns($session['userid']);
            $result = view("Modules/vis/vis_main_view.php", array('user' => $user->get($session['userid']), 'feedlist'=>$feedlist, 'apikey'=>$read_apikey, 'visualisations'=>$visualisations, 'multigraphs'=>$multigraphs));
        }

        // Auto - automatically selects visualisation based on datatype
        // and is used primarily for quick checking feeds from the feeds page.
        if ($route->action == "auto")
        {
            $feedid = intval(get('feedid'));
            $datatype = $feed->get_field($feedid,'datatype');
            if ($datatype == 0) $result = "Feed type or authentication not valid";
            if ($datatype == 1) $route->action = 'rawdata';
            if ($datatype == 2) $route->action = 'bargraph';
            if ($datatype == 3) $route->action = 'histgraph';
        }
        //error_log($route->format." ".$route->action."\n", 3, "errori.log");
        while ($vis = current($visualisations))
        {
            $viskey = key($visualisations);

            // If the visualisation has a set property called action
            // then override the visualisation key and use the set action instead
            if (isset($vis['action'])) $viskey = $vis['action'];
       
            if ($route->action == $viskey)
            {
                $array = array();
                $array['valid'] = true;

                if (isset($vis['options']))
                {
                    foreach ($vis['options'] as $option)
                    {
                        $key = $option[0]; $type = $option[1];
                        if (isset($option[2])) $default = $option[2]; else $default = "";
               
                        if ($type==1 || $type==2 || $type==3) 
                        {
                            $array[$key] = intval(get($key));
                            $array[$key.'name'] = $feed->get_field(intval(get($key)),'name');
                            // doda ime feeda na ime idfeeda vidi compare2017
                            //error_log($array[$key.'name'], 0);
                            if (!$feed->feedtype_belongs_user_or_public($array[$key], $session['userid'], $type)) $array['valid'] = false;
                        }

                        // Boolean not used at the moment
                        if ($type==4) if (get($key)==true || get($key)==false) $array[$key] = get($key); else $array[$key] = $default;
                        if ($type==5) $array[$key] = preg_replace('/[^\w\s£$€¥]/','',get($key))?get($key):$default;
                        if ($type==6) $array[$key] = str_replace(',', '.', floatval((get($key)?get($key):$default)));
                        if ($type==7) $array[$key] = intval((get($key)?get($key):$default));
                    }
                }

                $array['apikey'] = $read_apikey;
                $array['write_apikey'] = $write_apikey;

               
                if (!array_key_exists('start', $array)) {
                  if ($session['dateod']<1) { 
                    $session['dateod'] = time()-(3600*24.0*7);
                    $session['datedo'] = time();
                  }  
                  $array['start'] = $session['dateod'];
                  //error_log("vis dateod:".$session['dateod']."\n", 3, "errori.log");
             
                  
                  $array['end'] = $session['datedo'];
                  //error_log("vis datedo:".$session['datedo']."\n", 3, "errori.log");  
                }
                //error_log($viskey." arr:".print_r($array,TRUE)."\n", 3, "errori.log");
                
                // kod graphtable nije bitna
                if ($viskey == "graphtable") $array['valid'] = true;
                $result = view("Modules/".$visdir.$viskey.".php", $array);

                if ($viskey == "graphtable4h") $array['valid'] = true;
                $result = view("Modules/".$visdir.$viskey.".php", $array);

               
                if ($array['valid'] == false) $result .= "<div style='position:absolute; top:0px; left:0px; background-color:rgba(255,255,255,0.5); width:100%; height:100%; text-align:center; padding-top:100px;'><h3>Vrsta podatka ili autentikacija nije ispravna</h3></div>";

            }
            next($visualisations);
        }
    }

    /*

    MULTIGRAPH ACTIONS

    */

    if ($route->format == 'json' && $route->action == 'multigraph')
    {
        if ($route->subaction == 'new' && $session['write']) $result = $multigraph->create($session['userid']);
        if ($route->subaction == 'delete' && $session['write']) $result = $multigraph->delete(get('id'),$session['userid']);
        if ($route->subaction == 'set' && $session['write']) $result = $multigraph->set(get('id'),$session['userid'],get('feedlist'));
        if ($route->subaction == 'get') $result = $multigraph->get(get('id'),$session['userid']);
        if ($route->subaction == 'getlist') $result = $multigraph->getlist($session['userid']);
    }

    return array('content'=>$result);
  }

?>